const fs = require('fs');
const archiver = require('archiver');
const packageJson = require("../package.json");

const output = fs.createWriteStream(`./dist/${packageJson.hash}@${packageJson.version}.zip`);

const archive = archiver('zip', {zlib: {level: 9}});

output.on('close', function() {
  console.log(archive.pointer() + ' total bytes');
  console.log('archiver has been finalized and the output file descriptor has closed.');
});
output.on('end', function() {
  console.log('Data has been drained');
});
archive.on('warning', function(err) {
  if (err.code === 'ENOENT') {
    // log warning
    console.log(err);
  } else {
    // throw error
    throw err;
  }
});
archive.pipe(output);

archive.file(`./dist/index.js`, {name: 'index.js'});
archive.directory(`./dist/statics/`, 'statics');

archive.finalize();