// Generated with util/create-component.js
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import Card from './card';
import Base from '../base'
import type {DatasourceType, EventsType} from '../base'
import type { CardOptionsType } from './card.types'

export interface optionsType {
  
}


export default class CardClass extends Base {
  constructor(dom: string | Element, options: CardOptionsType) {
    super(dom, options)
    Object.assign(this.options, options)
  }
  static type = 'Card';
  static cnName = "卡片";
  static childrenType = []; // 支持的子组件类型
  static icon = '';
  static defaultValues = {
    layout: {
      width: 300,
      height: 200,
    },
    options: {
      title: '卡片标题',
      svgRadius: true,
      radiusColor: '#00a6fd',
      radiusLength: 30,
      radiusWidth: 5,
      radius: 0,
      borderWidth: 1,
      borderColor: '#12578e',
      boxShadowInset: true,
      boxShadowIntensity: 10,
      headerBackground: '#0d324b',
      headerHeight: 60,
      headerSpace: 10,
      bodyBackground: '#16204780',
    },
    datasource: [{
      type: 'JSON',
      data: '{"type": "Card"}',
    }],
    events: {},
  };
  static schemas = {
    options: [
      {
        title: '卡片标题',
        width: 150,
        dataIndex: 'title',
      },
      {
        valueType: 'group',
        columns: [
          
          {
            title: '特殊圆角',
            width: 50,
            dataIndex: 'svgRadius',
            valueType: 'switch',
          },
          {
            title: '圆角颜色',
            dataIndex: 'radiusColor',
            valueType: 'color',
          },
          {
            title: '圆角长度',
            width: 50,
            dataIndex: 'radiusLength',
            valueType: 'digit',
          },
          {
            title: '圆角宽度',
            width: 50,
            dataIndex: 'radiusWidth',
            valueType: 'digit',
          },
        ],
      },
      {
        valueType: 'group',
        columns: [
          {
            title: '边框宽度',
            width: 50,
            dataIndex: 'borderWidth',
            valueType: 'digit',
          },
          {
            title: '边框颜色',
            dataIndex: 'borderColor',
            valueType: 'color',
          },
          {
            title: '内阴影',
            width: 50,
            dataIndex: 'boxShadowInset',
            valueType: 'switch',
          },
          {
            title: '阴影强度',
            width: 50,
            dataIndex: 'boxShadowIntensity',
            valueType: 'digit',
          },
        ],
      },
      {
        valueType: 'group',
        columns: [
          {
            title: '背景颜色',
            dataIndex: 'bodyBackground',
            valueType: 'color',
          },
          {
            title: '标题背景',
            dataIndex: 'headerBackground',
            valueType: 'color',
          },
          {
            title: '标题高度',
            width: 50,
            dataIndex: 'headerHeight',
            valueType: 'digit',
          }, {
            title: '条纹间隔',
            width: 50,
            dataIndex: 'headerSpace',
            valueType: 'digit',
          }
        ]
      }      
    ],
    datasource: [],
    events: [],
  };

  public dom: Element

  public options: CardOptionsType = {
    type: 'Card',
    ...CardClass.defaultValues.options,
  };

  public datasource: DatasourceType[] = [
    CardClass.defaultValues.datasource[0]
  ];

  public events: EventsType = {
    ...CardClass.defaultValues.events,
  };



  // setOptions() {
  //  可自定义触发函数 用于参数更改
  // }

  // resize() {
  //  可自定义触发函数 用于布局更新
  // }

  // updateData() {
  //  可自定义触发函数 用于数据更新
  // }

  render() {
    // Object.assign(this.options, options) // 组件实例化好后平台会统一执行render函数
    this.dom &&
      ReactDOM.render(
        React.createElement(Card, {
          options: this.options?._options,
          _this: this
        }),
        this.dom
      );
    this.emit("rendered");
  }
}
