module.exports = (componentName, componentCamelName) => ({
  content: `// Generated with util/create-component.js
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import ${componentCamelName} from './${componentName}';
import Base from '../base'
import type {DatasourceType} from '../base'
import type {${componentCamelName}OptionsType} from './${componentName}.types'

export interface optionsType {
  
}

export default class ${componentCamelName}Class extends Base {
  constructor(dom: string | Element, options: ${componentCamelName}OptionsType) {
    super(dom, options)
    Object.assign(this.options, options)
  }
  static type = '${componentCamelName}';
  static cnName = "组件中文名";
  static category = "组件分类";
  static childrenType = []; // 支持的子组件类型
  static icon = '';
  static treeIcon = '';
  static defaultValues = {
    options: {},
    datasource: [{
      type: 'JSON',
      data: '{"type": "${componentCamelName}"}',
    }],
    events: {},
  };
  static schemas = {
    options: [],
    datasource: [],  // 正常使用可以不用理会数据源配置
    events: {
      
    },
  };

  public dom: Element

  public options: ${componentCamelName}OptionsType = {
    type: '${componentCamelName}',
    ...${componentCamelName}Class.defaultValues.options,
  };

  public datasource: DatasourceType[] = [
    ${componentCamelName}Class.defaultValues.datasource[0]
  ];


  // setOptions(info) {
  //   // 可自定义触发函数 用于参数更改
  //   Base.prototype.setOptions.call(this, info)
  // }

  // resize() {
  //  可自定义触发函数 用于布局更新
  // }

  render() {
    this.dom &&
      ReactDOM.render(
        React.createElement(${componentCamelName}, {
          options: this.options,
          _this: this
        }),
        this.dom
      );
    this.emit('rendered');
  }
    
}
`,
  main: true,
  extension: '.ts'
})
