module.exports = (componentName, componentCamelName) => ({
  content: `// Generated with util/create-component.js
import React from "react";
import { render } from "@testing-library/react";

import ${componentCamelName} from "./${componentName}";
import { ${componentCamelName}Props } from "./${componentName}.types";

describe("Test Component", () => {
  let props: ${componentCamelName}Props;

  beforeEach(() => {
    props = {
      options: {
        type: "${componentCamelName}"
      }
    };
  });

  const renderComponent = () => render(<${componentCamelName} {...props} />);

  it("should render foo text correctly", () => {
    props.options.type = "${componentCamelName}";
    const { getByTestId } = renderComponent();

    const component = getByTestId("${componentName}");

    expect(component).toHaveTextContent("${componentCamelName}");
  });
});
`,
  extension: '.test.tsx'
})
